;file: cstart.asm
.286

extrn   main_:near

; This module (cstart<_t>.obj) should be linked as first part of your program

ifdef   __TINY__
DGROUP  GROUP _TEXT, CONST, CONST2, _DATA, _BSS
else    ; ifdef __TINY__
DGROUP  GROUP CONST, CONST2, _DATA, _BSS, STACK
endif   ; ifdef __TINY__

_TEXT   SEGMENT PARA PUBLIC 'CODE'

ifdef   __TINY__
        ASSUME cs:DGROUP, ds:DGROUP, es:DGROUP, ss:DGROUP
        ORG 100h
else    ; ifdef __TINY__
        ASSUME cs:_TEXT, ds:DGROUP, es:DGROUP, ss:DGROUP
endif   ; ifdef __TINY__

_cstart_:

ifdef   __TINY__
else    ; ifdef __TINY__
; Init segment registers:
        mov     ax, DGROUP
        mov     ds, ax
        mov     es, ax
; Set the stack pointer to the end of the data segment
; (remember SS = DS for normal small model in Borland/Turbo C/C++),
; this makes things pretty much the same as with .COM files
; (e.g. tiny memory model, where CS = DS = ES = SS and the stack
; is in the end of the segment of the .COM program):
        cli
        mov     ss, ax
        xor     ax, ax
        mov     sp, ax
        sti
endif   ; ifdef __TINY__

        call    main_
        mov     ax, 4c00h
        int     21h
_TEXT   ENDS

; Declare empty data segments in this module:
CONST   SEGMENT PARA PUBLIC 'DATA'
CONST   ENDS

CONST2  SEGMENT PARA PUBLIC 'DATA'
CONST2  ENDS

_DATA   SEGMENT PARA PUBLIC 'DATA'
_DATA   ENDS

_BSS    SEGMENT PARA PUBLIC 'BSS'
_BSS    ENDS

ifdef   __TINY__
else    ; ifdef __TINY__
; Allocate a small stack to avoid WLINK warnings:
STACK   SEGMENT STACK PARA 'STACK'
        DB 512 DUP (?)
STACK   ENDS
endif   ; ifdef __TINY__

END _cstart_
